
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

        Asset( "ANIM", "anim/fed.zip" ),
        Asset( "ANIM", "anim/ghost_fed_build.zip" ),
}
local prefabs = {}

-- Custom starting items
local start_inv = {
	"papyrus",
    "papyrus",
	"carrot",
	"carrot",
	"carrot",
	"carrot",
}

-- When the character is revived from human
local function onbecamehuman(inst)
	-- Set speed when loading or reviving from ghost (optional)
	inst.components.locomotor.walkspeed = 4.5
	inst.components.locomotor.runspeed = 7
end

local function onkill(inst, data)
	if data.afflicter == inst 
		and data.inst.prefab == "rabbit" then 
        inst.components.sanity:DoDelta(-20)
	end	
end

-- When loading or spawning the character
local function onload(inst)
    inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)

    if not inst:HasTag("playerghost") then
        onbecamehuman(inst)
    end
end
local function common_postinit(inst)
  
    inst:AddTag("bookbuilder")
	--Rabbit Power
	inst:RemoveTag("scarytoprey")
	-- Minimap icon
	inst.MiniMapEntity:SetIcon( "fed.tex" )
end

-- Zanahoria Power
local function oneat(inst, food)
	if food and food.components.edible and food.prefab == "carrot"  then
		inst.components.hunger:DoDelta(food.components.edible:GetHunger(inst)*0.3);
		inst.components.sanity:DoDelta(10);
		inst.components.health:DoDelta((food.components.edible:GetHealth(inst)+2)*2, nil, food.prefab);
	end
	
	if food and food.components.edible and food.prefab == "carrot_cooked"  then
		inst.components.hunger:DoDelta(food.components.edible:GetHunger(inst)*0.3);
		inst.components.sanity:DoDelta(12);
		inst.components.health:DoDelta((food.components.edible:GetHealth(inst)+2)*2, nil, food.prefab);
	end
end

-- This initializes for the server only. Components are added here.
local master_postinit = function(inst)
	inst.level = 0
	-- choose which sounds this character will play
	inst.soundsname = "wickerbottom"
	
	-- Uncomment if "wathgrithr"(Wigfrid) or "webber" voice is used
    --inst.talker_path_override = "dontstarve_DLC001/characters/"
	
	-- Stats	(line 106)
	inst.components.health:SetMaxHealth(150)
	inst.components.hunger:SetMax(150)
	inst.components.sanity:SetMax(150)
	inst.components.locomotor.walkspeed = (4.5)
	inst.components.locomotor.runspeed = (7)
	inst.components.temperature.inherentinsulation =(TUNING.INSULATION_PER_BEARD_BIT * 2)
	inst.components.eater:SetDiet( { FOODGROUP.OMNI }, { FOODTYPE.VEGGIE, FOODTYPE.SEEDS, FOODTYPE.GENERIC } )
	-- Damage multiplier (optional)
    --inst.components.combat.damagemultiplier = 0.5
	
	-- Hunger rate (optional)
	--inst.components.hunger.hungerrate = 1 * TUNING.WILSON_HUNGER_RATE
	
	inst:AddComponent("reader")
	inst.components.builder.science_bonus = 1
	
	-- Estos tag los podes eliminar, ya los pusistes en las lineas 72 y 73
	 --inst:AddTag("insomniac")
	
	inst:ListenForEvent("entity_death", function(wrld, data) onkill(inst, data) end, TheWorld)		
	
	inst.OnLoad = onload
    inst.OnNewSpawn = onload
end

return MakePlayerCharacter("fed", prefabs, assets, common_postinit, master_postinit, start_inv)
